#pragma once

#include <core/global_definitions.hpp>
#include <gpu/gpu_base_column.hpp>

namespace CoGaDB{

//template <typename T> 
//const std::vector<unsigned int> gpu_sort(std::vector<T> values_in_column);

int CUDA_device_check(int gpudevice);

int check_for_CUDA_devices();

unsigned int getNumberofGPUMultiprocessors();

unsigned int getTotalGPUMemorySizeInByte();

unsigned int getFreeGPUMemorySizeInByte();

void printGPUStatus();

const std::vector<std::pair<unsigned int,unsigned int> > gpu_join_tids(std::vector<int>& join_column1, std::vector<int>& join_column2);

//template <typename T>
//const std::vector<unsigned int> gpu_selection_tids(const std::vector<T>& column, T value, ValueComparator comp);

	namespace gpu{
	
		class GPU_Operators{
			public:
			/***************** relational operations on Columns which return lookup tables *****************/
			static const GPU_PositionlistPtr sort(GPU_Base_ColumnPtr device_column, SortOrder order); 
			static const GPU_PositionlistPtr selection(GPU_Base_ColumnPtr column, const boost::any& value_for_comparison, const ValueComparator comp);
			//join algorithms
//			static const std::pair<GPU_Positionlist*,GPU_Positionlist*> gpu_join(GPU_Base_Column* join_column1, GPU_Base_Column* join_column2, JoinAlgorithm join_alg);
			static const std::pair<GPU_Base_ColumnPtr,GPU_Base_ColumnPtr> groupby(GPU_Base_ColumnPtr grouping_column, 
																										 GPU_Base_ColumnPtr aggregation_column,  
																										 AggregationMethod agg_meth=SUM);

			static const GPU_Base_ColumnPtr materializeIntermediateResult(GPU_Base_ColumnPtr column, GPU_PositionlistPtr pos_list); 

			static const std::pair<GPU_PositionlistPtr,GPU_PositionlistPtr>  hash_join(GPU_Base_ColumnPtr join_column1, GPU_Base_ColumnPtr join_column2);
			static const std::pair<GPU_PositionlistPtr,GPU_PositionlistPtr>  sort_merge_join(GPU_Base_ColumnPtr join_column1, GPU_Base_ColumnPtr join_column2);
			static const std::pair<GPU_PositionlistPtr,GPU_PositionlistPtr>  nested_loop_join(GPU_Base_ColumnPtr join_column1, GPU_Base_ColumnPtr join_column2);
		};
	
//		#ifdef __CUDACC__
//			class GPU_Base_Column{};
//		#endif 
	
	}; //end namespace gpu
}; //end namespace CogaDB

