
#pragma once

#include <string>

#include <core/table.hpp>

#include<boost/tokenizer.hpp>

namespace CoGaDB {

    class CommandLineInterpreter {
    public:
        CommandLineInterpreter();

        bool execute(const std::string& command);
        bool getline(const std::string &prompt, std::string &result);

    private:
        typedef bool (*SimpleCommandHandlerPtr)();
        typedef bool (*ParameterizedCommandHandlerPtr)(const std::string&);
        typedef std::map<std::string, SimpleCommandHandlerPtr> SimpleCommandMap;
        typedef std::map<std::string, ParameterizedCommandHandlerPtr> ParameterizedCommandMap;
        SimpleCommandMap simple_command_map_;
        ParameterizedCommandMap command_map_;
        std::string prompt_;
    };




} //end namespace CogaDB


