#pragma once

#include <hype.hpp>
#include <query_processing/processing_device.hpp>
#include <query_processing/logical_query_plan.hpp>
#include <cstdlib>
#include <functional>
#include <algorithm>
#include <stack>
#include <boost/date_time.hpp>
#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/function.hpp>
#include <boost/bind.hpp>
//CoGaDB
#include <core/base_table.hpp>
#include <core/runtime_configuration.hpp>
#include <gpu/gpu_base_column.hpp>
namespace CoGaDB
{
	namespace query_processing
	{
		//Table-based query processing (hardware oblivious)
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::Map_Init_Function Map_Init_Function;
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::Physical_Operator_Map Physical_Operator_Map;
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::Physical_Operator_Map_Ptr Physical_Operator_Map_Ptr;
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::TypedOperatorPtr TypedOperatorPtr;
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::TypedLogicalNode TypedLogicalNode;
                typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::TypedNodePtr TypedNodePtr;
                typedef hype::queryprocessing::NodePtr NodePtr;                
		typedef hype::queryprocessing::OperatorMapper_Helper_Template<TablePtr>::PhysicalQueryPlanPtr PhysicalQueryPlanPtr;
		typedef hype::queryprocessing::LogicalQueryPlan<TablePtr> LogicalQueryPlan;
                typedef boost::shared_ptr<LogicalQueryPlan> LogicalQueryPlanPtr;

//		//Column-based query processing on CPU (hardware aware)		
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Map_Init_Function ColumnWise_Map_Init_Function;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Physical_Operator_Map ColumnWise_Physical_Operator_Map;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Physical_Operator_Map_Ptr ColumnWise_Physical_Operator_Map_Ptr;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::TypedOperatorPtr ColumnWise_TypedOperatorPtr;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::TypedLogicalNode ColumnWise_TypedLogicalNode;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::PhysicalQueryPlanPtr ColumnWise_PhysicalQueryPlanPtr;
//		typedef hype::queryprocessing::LogicalQueryPlan<ColumnPtr> ColumnWise_LogicalQueryPlan;

//		//Column-based query processing on GPU(hardware aware)			
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Map_Init_Function GPU_ColumnWise_Map_Init_Function;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Physical_Operator_Map GPU_ColumnWise_Physical_Operator_Map;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::Physical_Operator_Map_Ptr GPU_ColumnWise_Physical_Operator_Map_Ptr;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::TypedOperatorPtr GPU_ColumnWise_TypedOperatorPtr;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::TypedLogicalNode GPU_ColumnWise_TypedLogicalNode;
//		typedef hype::queryprocessing::OperatorMapper_Helper_Template<ColumnPtr>::PhysicalQueryPlanPtr GPU_ColumnWise_PhysicalQueryPlanPtr;
//		typedef hype::queryprocessing::LogicalQueryPlan<ColumnPtr> GPU_ColumnWise_LogicalQueryPlan;

		
	}//end namespace query_processing
}; //end namespace CogaDB
