
#pragma once

#include <hype.hpp>

namespace CoGaDB{

typedef hype::DeviceSpecification DeviceSpecification;

class HardwareDetector{
	public:
		typedef std::vector<hype::DeviceSpecification> DeviceSpecifications;	
		static HardwareDetector& instance();
		const DeviceSpecifications& getDeviceSpecifications();	
	private:
		HardwareDetector();
		HardwareDetector(const HardwareDetector&);
		HardwareDetector& operator=(HardwareDetector&);
		DeviceSpecifications dev_specs_;
};

typedef HardwareDetector::DeviceSpecifications DeviceSpecifications;

		/* \brief convinience function, adds an algorithm specified by AlgorithmSpecification to all available processing devices detected by the HardwareDetector */
		//bool addAlgorithmSpecificationToHardware(const AlgorithmSpecification&);

}; //end namespace CogaDB


