
#include <core/data_dictionary.hpp>
#include <persistence/storage_manager.hpp>

namespace CoGaDB{


        DataDictionary::DataDictionary(){
        
        }
    
        DataDictionary& DataDictionary::instance(){
            static DataDictionary dd;
            return dd;
        }

        std::list<std::pair<ColumnPtr,TablePtr> > DataDictionary::getColumnsforColumnName(const std::string& column_name){
            std::list<std::pair<ColumnPtr,TablePtr> > result;
            std::vector<TablePtr>& tables = CoGaDB::getGlobalTableList();
            for(unsigned int i=0;i<tables.size();++i){
                TableSchema schema = tables[i]->getSchema();
                for(TableSchema::iterator it=schema.begin();it!=schema.end();++it){
                    if(it->second==column_name){
                        ColumnPtr col = tables[i]->getColumnbyName(column_name);
                        result.push_back(std::make_pair(col,tables[i]));
                        
                    }
                }
            }
            return result;            
        }
        
        bool DataDictionary::getAttributeType(const std::string& table_name, const std::string& column_name, AttributeType& result_attribute_type){
            std::vector<TablePtr>& tables = CoGaDB::getGlobalTableList();
            for(unsigned int i=0;i<tables.size();++i){
                TableSchema schema = tables[i]->getSchema();
                for(TableSchema::iterator it=schema.begin();it!=schema.end();++it){
                    if(it->second==column_name){
                        result_attribute_type=it->first;
                        return true;
                    }
                }
            }
            return false;
        }
        
}; //end namespace CoGaDB
    
