

#include<core/runtime_configuration.hpp>

namespace CoGaDB{

    RuntimeConfiguration::RuntimeConfiguration() : path_to_database_("./data"), print_query_plan_(false), global_device_constraint_(hype::ANY_DEVICE),two_phase_physical_optimization_parallelization_mode(SERIAL), enable_query_chopping_(false) {
    }

		RuntimeConfiguration& RuntimeConfiguration::instance(){
			static RuntimeConfiguration runtime_config;
			return runtime_config;
		}

		void RuntimeConfiguration::setPathToDatabase(const std::string& val){
			path_to_database_=val;
		}

		const std::string& RuntimeConfiguration::getPathToDatabase(){
			return path_to_database_;
		}

                void RuntimeConfiguration::setParallelizationModeForTwoPhasePhysicalOptimizationQueryPlans(ParallelizationMode value){
                    this->two_phase_physical_optimization_parallelization_mode=value;
                }
                ParallelizationMode RuntimeConfiguration::getParallelizationModeForTwoPhasePhysicalOptimizationQueryPlans() const{
                    return this->two_phase_physical_optimization_parallelization_mode;
                }
                
                void RuntimeConfiguration::setPrintQueryPlan(bool value){
			this->print_query_plan_=value;
		}
                bool RuntimeConfiguration::getPrintQueryPlan() const{
			return this->print_query_plan_;
		}
                bool RuntimeConfiguration::setGlobalDeviceConstraint(const hype::DeviceConstraint& value){
			this->global_device_constraint_=value;
		}
                hype::DeviceConstraint RuntimeConfiguration::getGlobalDeviceConstraint() const{
			return this->global_device_constraint_;
		}
                
    void RuntimeConfiguration::setQueryChoppingEnabled(bool value) {
        this->enable_query_chopping_ = value;
    }

    bool RuntimeConfiguration::isQueryChoppingEnabled() const {
        return this->enable_query_chopping_;
    }
}; //end namespace CogaDB

