
#include <query_processing/query_processor.hpp>
#include <sql/server/sql_driver.hpp>

#include <iostream>
#include <string>
#include <exception>

using namespace std;
using namespace CoGaDB;
using namespace query_processing;

int
main(int argc, char **argv)
{
	SQL::Driver driver;
	SQL::ParseTree::SequencePtr seq;
	TablePtr result;

	seq = driver.parse("\
		CREATE TABLE \"Shop\" (\"ID\" INT, \"Name\" VARCHAR);\
		INSERT INTO \"Shop\" VALUES (1, 'Tante Emma Laden');\
		INSERT INTO \"Shop\" VALUES (2, 'Aldi');\
		INSERT INTO \"Shop\" VALUES (3, 'Kaufland');\
	");
	seq->execute();

	try {
		if (argc > 1) {
			while (--argc)
				 result = driver.parse(*++argv)->execute();
		} else {
			result = driver.parse(cin)->execute();
		}
	} catch (const exception &e) {
		cerr << e.what() << endl;
		return 1;
	}

	if (result)
		result->print();
	else
		cout << "No result table!" << endl;

	return 0;
}
