
#include <util/hardware_detector.hpp>


namespace CoGaDB{

HardwareDetector::HardwareDetector() : dev_specs_(){
	//static setup for single CPU/single GPU platform
	dev_specs_.push_back(DeviceSpecification(hype::PD0,hype::CPU,hype::PD_Memory_0)); //one host CPU
	dev_specs_.push_back(DeviceSpecification(hype::PD1,hype::GPU,hype::PD_Memory_1)); //one dedicated GPU
}

HardwareDetector& HardwareDetector::instance(){
	static HardwareDetector hwd;
	return hwd; 
}


const DeviceSpecifications& HardwareDetector::getDeviceSpecifications(){
	return dev_specs_;
}


}; //end namespace CogaDB


