
#include <util/get_name.hpp>

namespace hype{
	namespace util{

	const std::string getName(StatisticalMethod x){
	
		const char * const statistical_method_names[] = {"Least Squares 1D","Least Squares 2D"};
		
		return std::string(statistical_method_names[x]);
		
	};
	
	const std::string getName(RecomputationHeuristic x){
	
		const char * const recomputation_heuristic_names[] = {"Oneshot Recomputation","Periodic Recomputation"};
		
		return std::string(recomputation_heuristic_names[x]);
//	
//		struct RecomputationHeuristics{
//		enum RecomputationHeuristic{
//			No_Recomputation,
//			Periodic
//		};
//	};
		};
	
	const std::string getName(OptimizationCriterion x){
	
		const char * const optimization_criterion_names[] = {"Response Time","WaitingTimeAwareResponseTime","Throughput","Simple Round Robin","ProbabilityBasedOutsourcing","Throughput2"};

		return std::string(optimization_criterion_names[x]);
		
//	struct OptimizationCriterions{
//		enum OptimizationCriterion{
//			ResponseTime,
//			WaitingTimeAwareResponseTime,
//			Throughput,
//			Simple_Round_Robin,
//			ProbabilityBasedOutsourcing,
//			Throughput2
//		};
//	};
		
	};
	
	const std::string getName(ProcessingDeviceType x){
		//	enum ProcessingDeviceType{CPU,GPU,FPGA,NP};	//CPU,GPU,FPGA, Network Processor
		const char * const names[] = {"CPU","GPU","FPGA","NP"};

		return std::string(names[x]);			
	}	

	const std::string getName(DeviceTypeConstraint x){
		//	enum DeviceTypeConstraint{ANY_DEVICE,CPU_ONLY,GPU_ONLY,FPGA_ONLY,NP_ONLY};
		const char * const names[] = {"ANY_DEVICE","CPU_ONLY","GPU_ONLY","FPGA_ONLY","NP_ONLY"};

		return std::string(names[x]);			
	}	

	
	}; //end namespace util
}; //end namespace hype

